
// uses VCL Form as an editor.

#include <vcl.h>
#include <windows.h>
#include "../../include/ARPluginHelper.h"
#include "Unit1.h"

#define EFFECT_ID 4456
#define EFFECT_VERSION 1

#define EFFECT_EDITOR_WIDTH 256
#define EFFECT_EDITOR_HEIGHT 115

#pragma hdrstop
#pragma argsused


class ExamplePlugin4 : public ARPluginHelper
{
	PluginState state;
	TForm1* form1;
public:

	ExamplePlugin4()
	{
	   state.amount = 50;
	}

	virtual ~ExamplePlugin4()
	{

	}

	void STDCALL GetEffectName(RString** ppText)
	{
		*ppText = MakeRString(L"Audio Gain");
	}

	int STDCALL GetEffectID()
	{
		return EFFECT_ID;
	}

	int STDCALL GetEffectVersion()
	{
		return EFFECT_VERSION;
	}

	void STDCALL GetEditorSize(int *width, int *height)
	{
		*width = EFFECT_EDITOR_WIDTH;
		*height = EFFECT_EDITOR_HEIGHT;
	}

	void STDCALL CreateEditor(HWND parentWindow)
	{
	   form1 = new TForm1(0, &state);
	   form1->ParentWindow = parentWindow;
	   form1->Visible = true;
	}

	void STDCALL DestroyEditor()
	{
	  delete form1;
	}

	void STDCALL ProcessAudio(float **inputs, float **outputs, long frameCount)
	{
		float mul = (state.amount / 100.0f) * 2;

		for (int i = 0; i < frameCount; ++i)
		{
			outputs[0][i] = mul * inputs[0][i];
			outputs[1][i] = mul * inputs[1][i];
		}
	}

	void STDCALL LoadState(void *data, int size)
	{
		if (size == sizeof(PluginState))
		{
			state.amount = ((PluginState*)data)->amount;

			if (form1) // update gui if created
			{
				form1->TrackBar1->Position = state.amount;
			}
		}
	}

	int STDCALL SaveState(void **data)
	{
		*data = &state;
		return sizeof(PluginState);
	}

	IMPLEMENTS_RUNKNOWN_METHODS
};


EXPORT_EFFECT(ExamplePlugin4)


