
// Helper class to create audio effect plugins quickly!!!

#ifndef _ARPLUGIN_HELPER_H_
#define _ARPLUGIN_HELPER_H_

#include "ARObjects.h"

class ARPluginHelper : public CRUnknown, public RAudioEffect
{
protected:
	UserInterfaceAPI* interfaceAPI;
	ARFactory* factory;
	HINSTANCE hInstance;

public:
	ARPluginHelper()
	{
		interfaceAPI = 0;
		factory = 0;
	}

	virtual ~ARPluginHelper()
	{
		if (interfaceAPI)
			interfaceAPI->Release();

		if (factory)
			factory->Release();
	}

	virtual int STDCALL Initialize(HINSTANCE hInstance, int hostID, void* hostParam)
	{
		if (hostID == AUDIO_REPEATER_PRO_HOST_ID)
		{
			this->hInstance = hInstance;

			factory = (ARFactory*)hostParam;
			factory->AddRef();

			if (factory->GetAPIObject(AUDIO_REPEATER_PRO_GUI_API, (void**)&interfaceAPI) == R_OK)
				return 1;
		}

		return 0;
	}

	virtual void STDCALL GetEffectName(RString** ppText)
	{
		*ppText = MakeRString(L"Unknown Effect");
	}

	virtual int STDCALL GetEffectID()
	{
		return 1000;
	}

	virtual int STDCALL GetEffectVersion()
	{
		return 1;
	}

	virtual int STDCALL SetChannelCount(int inputChannelCount, int outputChannelCount)
	{
		if ((inputChannelCount == 2) && (outputChannelCount == 2))
			return 1;

		return 0;
	}

	virtual void STDCALL SetSampleRate(float srate)
	{

	}

	virtual void STDCALL SetBlockSize(int blockSize)
	{

	}

	virtual void STDCALL CreateEditor(HWND containerWnd)
	{

	}

	virtual void STDCALL GetEditorSize(int *width, int *height)
	{
		*width = 200;
		*height = 100;
	}

	virtual void STDCALL DestroyEditor()
	{

	}

	virtual void STDCALL LoadState(void *data, int size)
	{

	}

	virtual void STDCALL StartProcess()
	{

	}

	virtual void STDCALL ProcessAudio(float **inputs, float **outputs, long frameCount)
	{
		for (int i = 0; i < frameCount; ++i)
		{
			outputs[0][i] = inputs[0][i];
			outputs[1][i] = inputs[1][i];
		}
	}

	virtual void STDCALL StopProcess()
	{

	}

	virtual int STDCALL SaveState(void **data)
	{
		return 0;
	}

	virtual void STDCALL Shutdown()
	{

	}
};

#endif