

#include "../include/RAudioEffect.h"

// use your own id
#define EFFECT_ID 4455
#define EFFECT_VERSION 1

typedef struct {
	RAudioEffectVtbl* pVtblRAudioEffect;

	//=====================================
	long refCount;
	//=====================================

} ExampleEffect1;

IMPLEMENT_RUNKNOWN_FUNCTIONS(ExampleEffect1, RAudioEffectVtbl)

int STDCALL RAudioEffectVtbl_Initialize(void* _this, HINSTANCE hInstance, int hostID, void* hostParam)
{
	return 1;
}

void STDCALL RAudioEffectVtbl_GetEffectName(void* _this, RString** ppText)
{
	*ppText = MakeRString(L"Dummy Effect");
}

int STDCALL RAudioEffectVtbl_GetEffectID(void* _this)
{
	return EFFECT_ID;
}

int STDCALL RAudioEffectVtbl_GetEffectVersion(void* _this)
{
	return EFFECT_VERSION;
}

int STDCALL RAudioEffectVtbl_SetChannelCount(void* _this, int inputChannelCount, int outputChannelCount)
{
	if ( (inputChannelCount == 2) && (outputChannelCount == 2) )
		return 1;

	return 0;
}

void STDCALL RAudioEffectVtbl_SetSampleRate(void* _this, float srate)
{

}

void STDCALL RAudioEffectVtbl_SetBlockSize(void* _this, int blockSize)
{

}

void STDCALL RAudioEffectVtbl_GetEditorSize(void* _this, int* width, int* height)
{
	*width = 200;
	*height = 100;
}

void STDCALL RAudioEffectVtbl_CreateEditor(void* _this, HWND parentWindow)
{

}

void STDCALL RAudioEffectVtbl_DestroyEditor(void* _this)
{

}

void STDCALL RAudioEffectVtbl_LoadState(void* _this, void* data, int size)
{

}

void STDCALL RAudioEffectVtbl_StartProcess(void* _this)
{

}

void STDCALL RAudioEffectVtbl_ProcessAudio(void* _this, float** inputs, float** outputs, long frameCount)
{
	int i;
	for (i = 0; i < frameCount; ++i)
	{
		outputs[0][i] = inputs[0][i];
		outputs[1][i] = inputs[1][i];
	}
}

void STDCALL RAudioEffectVtbl_StopProcess(void* _this)
{

}

int STDCALL RAudioEffectVtbl_SaveState(void* _this, void** data)
{
	return 0;
}

void STDCALL RAudioEffectVtbl_Shutdown(void* _this)
{

}

// constructor
ExampleEffect1* ExampleEffect1_Create()
{
	//=====================================================================
	ExampleEffect1* this = NEW_OBJ(ExampleEffect1);
	this->pVtblRAudioEffect = NEW_VTABLE(RAudioEffectVtbl);
	this->pVtblRAudioEffect->this_ = this;

	VTABLE_FILL_RUNKNOWN_METHODS(RAudioEffectVtbl, this->pVtblRAudioEffect);
	VTABLE_FILL_RAUDIO_EFFECT_METHODS(RAudioEffectVtbl, this->pVtblRAudioEffect);
	//=====================================================================

	this->refCount = 1;
	return this;
}

// destructor
void ExampleEffect1_Destroy(ExampleEffect1* this)
{

	//=====================================================================
	FREE_VTABLE(this->pVtblRAudioEffect);
	FREE_OBJ(this);
	//=====================================================================
}


EXPORT_EFFECT(ExampleEffect1, pVtblRAudioEffect)