
// Common audio effect struct to be used with CrownSoft products.
// (c) 2018 CrownSoft

#ifndef _RAUDIO_EFFECT_H_
#define _RAUDIO_EFFECT_H_

#include "RObjBase.h"

typedef struct {
	//=====================================
	DECLARE_RUNKNOWN_VTABLE_ENTRIES
	//=====================================

	int (STDCALL *Initialize) (void*, HINSTANCE, int, void*);

	void (STDCALL *GetEffectName) (void*, RString**);

	int (STDCALL *GetEffectID) (void*);

	int (STDCALL *GetEffectVersion) (void*);

	int (STDCALL *SetChannelCount) (void*, int, int);

	void (STDCALL *SetSampleRate) (void*, float);

	void (STDCALL *SetBlockSize) (void*, int);

	void (STDCALL *CreateEditor) (void*, HWND);

	void (STDCALL *GetEditorSize) (void*, int*, int*);

	void (STDCALL *DestroyEditor) (void*);

	void (STDCALL *LoadState) (void*, void* data, int size);

	void (STDCALL *StartProcess) (void*);

	void (STDCALL *ProcessAudio) (void*, float** inputs, float** outputs, long frameCount);

	void (STDCALL *StopProcess) (void*);

	int (STDCALL *SaveState) (void*, void** data);

	void (STDCALL *Shutdown) (void*);

	//=====================================
	void* this_;
	//=====================================
} RAudioEffectVtbl;

#define RAudioEffect RAudioEffectVtbl*

#define VTABLE_FILL_RAUDIO_EFFECT_METHODS(vtblName, pVtbl) pVtbl->Initialize = &vtblName##_Initialize; \
	pVtbl->GetEffectName = &vtblName##_GetEffectName; \
	pVtbl->GetEffectID = &vtblName##_GetEffectID; \
	pVtbl->GetEffectVersion = &vtblName##_GetEffectVersion; \
	pVtbl->SetChannelCount = &vtblName##_SetChannelCount; \
	pVtbl->SetSampleRate = &vtblName##_SetSampleRate; \
	pVtbl->SetBlockSize = &vtblName##_SetBlockSize; \
	pVtbl->GetEditorSize = &vtblName##_GetEditorSize; \
	pVtbl->CreateEditor = &vtblName##_CreateEditor; \
	pVtbl->DestroyEditor = &vtblName##_DestroyEditor; \
	pVtbl->LoadState = &vtblName##_LoadState; \
	pVtbl->StartProcess = &vtblName##_StartProcess; \
	pVtbl->ProcessAudio = &vtblName##_ProcessAudio; \
	pVtbl->StopProcess = &vtblName##_StopProcess; \
	pVtbl->SaveState = &vtblName##_SaveState; \
	pVtbl->Shutdown = &vtblName##_Shutdown; 

#define EXPORT_EFFECT(implStructName, pVtbl) __declspec(dllexport) void STDCALL GetEffect(RAudioEffect** efffect) \
{ \
	implStructName* eff = implStructName##_Create(); \
	*efffect = &eff->pVtbl; \
} 

#endif