
// RObjBaseUnit (c) 2018 CrownSoft

unit RObjBaseUnit;

interface

uses
  Windows;

const
  R_OK = 0;
  R_ERROR = 1;
  R_NOINTERFACE = $80004002;
  R_TRUE = 1;
  R_FALSE = 0;

type
  R_BOOL = Integer;

  RString = interface
    procedure GetString(var ppText: PWideChar); stdcall;
    function GetLength: Integer; stdcall;
  end;

function MakeRString(txt: WideString): RString;

type
  CRString = class(TInterfacedObject, RString)
  protected
    Text: WideString;
    len: Integer;
  public
    constructor Create(txt: WideString);
    destructor Destroy; override;
    procedure GetString(var ppText: PWideChar); stdcall;
    function GetLength: Integer; stdcall;
  end;

implementation

constructor CRString.Create(txt: WideString);
begin
  inherited Create;
  Text := txt;
  len := Length(Text);
end;

destructor CRString.Destroy;
begin

  inherited;
end;

procedure CRString.GetString(var ppText: PWideChar); stdcall;
begin
  ppText := PWideChar(Text);
end;

function CRString.GetLength: Integer; stdcall;
begin
  Result := len;
end;

function MakeRString(txt: WideString): RString;
begin
  Result := CRString.Create(txt);
end;

end.
