
// Dummy Plug-In without GUI

library ExamplePlugin1;

uses
  Classes,
  Windows,
  RAudioEffectUnit in '../../Common/RAudioEffectUnit.pas',
  RObjBaseUnit in '../../Common/RObjBaseUnit.pas',
  ARObjectsUnit in '../../Common/ARObjectsUnit.pas',
  ARPluginHelperUnit in '../../Common/ARPluginHelperUnit.pas';

{$E ae}

{$R *.res}

type
  TExamplePlugin1 = class(ARPluginHelper)
  public
    procedure GetEffectName(var ppText: RString); override; stdcall;
    function GetEffectID: integer; override; stdcall;
    procedure GetEditorSize(Width, Height: PInteger); override; stdcall;
    procedure ProcessAudio(inputs, outputs: PPSingle; frameCount: integer); override; stdcall;
    constructor Create;
    destructor Destroy; override;
  end;

  constructor TExamplePlugin1.Create;
  begin
    inherited Create;

  end;

  destructor TExamplePlugin1.Destroy;
  begin

    inherited;
  end;

  procedure TExamplePlugin1.GetEffectName(var ppText: RString); stdcall;
  begin
    ppText := MakeRString('Dummy Plugin');
  end;

  function TExamplePlugin1.GetEffectID: integer; stdcall;
  begin
    Result := 4455; // use your own id
  end;

  procedure TExamplePlugin1.GetEditorSize(Width, Height: PInteger); stdcall;
  begin
    Width^ := 200;
    Height^ := 100;
  end;

  procedure TExamplePlugin1.ProcessAudio(inputs, outputs: PPSingle; frameCount: integer); stdcall;
  var
    index: integer;
    leftSample, rightSample: single;
    leftInBuffer, rightInBuffer: PSingle;
    leftOutBuffer, rightOutBuffer: PSingle;

  begin
    leftInBuffer := inputs^;
    Inc(inputs);
    rightInBuffer := inputs^;

    leftOutBuffer := outputs^;
    Inc(outputs);
    rightOutBuffer := outputs^;

    for index := 0 to frameCount - 1 do
    begin
      leftSample := leftInBuffer^;
      rightSample := rightInBuffer^;

      // process leftSample & rightSample here...

      leftOutBuffer^ := leftSample;
      rightOutBuffer^ := rightSample;

      // move on to the next sample
      Inc(leftInBuffer);
      Inc(rightInBuffer);
      Inc(leftOutBuffer);
      Inc(rightOutBuffer);
    end;
  end;


procedure GetEffect(var effect: RAudioEffect); stdcall;
  begin
    effect := TExamplePlugin1.Create;
  end;

exports
  GetEffect;

begin
end.
 