

#ifndef _ARGENERAL_PLUGIN_H_
#define _ARGENERAL_PLUGIN_H_

#include "ARGenInterfaces.h"

class ARGeneralPlugin : public CRUnknown, public RPlugin
{
protected:
	HINSTANCE hInstance;
	ARSystemAPI* systemAPI;

public:
	ARGeneralPlugin()
	{

	}

	virtual ~ARGeneralPlugin()
	{

	}

	virtual void STDCALL GetName(RString** ppText) override
	{
		*ppText = MakeRString(L"Unknown Plug-In");
	}

	virtual void STDCALL GetAuthor(RString** ppText) override
	{
		*ppText = MakeRString(L"Unknown");
	}

	virtual int STDCALL GetVersion() override
	{
		return 0;
	}

	virtual int STDCALL Initialize(HINSTANCE hInstance, int hostID, void* hostParam) override
	{
		if (hostID == AUDIO_REPEATER_PRO_HOST_ID)
		{
			this->hInstance = hInstance;

			ARSystemAPIFactory* apiFactory = (ARSystemAPIFactory*)hostParam;

			if (apiFactory->GetSystemAPI(AUDIO_REPEATER_PRO_SYSTEM_API_V2, (void**)&systemAPI) == R_OK)
				return 1;
		}

		return 0;
	}

	virtual void STDCALL LoadState(void* data, int size) override
	{

	}

	virtual void STDCALL Enable() override
	{

	}

	virtual void STDCALL Disable() override
	{

	}

	virtual int STDCALL SaveState(void** data) override
	{
		return 0;
	}

	virtual void STDCALL Stop() override
	{

	}

	virtual void STDCALL Free(int initOK) override
	{

	}
};


// use this macro to support registration using regsvr32 command.
// PluginIdAsString is the string version of the RGUID (with braces).
// you may need to add module file to remove msvc linker warnings.

#define SELF_REGISTER_PLUGIN(PluginIdAsString) \
HINSTANCE  argp_hInstance; \
 \
BOOL WINAPI DllMain( HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved) \
{ \
	if (dwReason == DLL_PROCESS_ATTACH) \
	{ argp_hInstance = hInstance; } \
	return TRUE; \
} \
 \
extern "C" __declspec(dllexport) HRESULT STDCALL DllRegisterServer() \
{ \
	HKEY hkey = 0; \
	if (::RegCreateKeyExW(HKEY_LOCAL_MACHINE, L"SOFTWARE\\CrownSoft\\AudioRepeaterPro\\Plugins\\" \
		PluginIdAsString, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hkey, NULL) != ERROR_SUCCESS) \
	{return S_FALSE;} \
	wchar_t dllPath[MAX_PATH * 2]; \
	::GetModuleFileNameW(argp_hInstance, dllPath, MAX_PATH * 2); \
	::RegSetValueExW(hkey, L"Path", 0, REG_SZ, (LPBYTE)dllPath, sizeof(wchar_t) * (::lstrlenW(dllPath) + 1)); \
	::RegCloseKey(hkey); \
	return S_OK; \
} \
 \
extern "C" __declspec(dllexport) HRESULT STDCALL DllUnregisterServer() \
{ \
	if(::RegDeleteKeyW(HKEY_LOCAL_MACHINE, L"SOFTWARE\\CrownSoft\\AudioRepeaterPro\\Plugins\\" \
		PluginIdAsString) != ERROR_SUCCESS) \
	{return S_FALSE;} \
	return S_OK; \
}


#endif

