
// ARGeneralPluginUnit (c) 2021 CrownSoft

unit ARGeneralPluginUnit;

interface

uses
  Classes, Windows, SysUtils,
  RObjBaseUnit, RPluginUnit, ARGenInterfacesUnit;

type
  ARGeneralPlugin = class(TInterfacedObject, RPlugin)
  protected
    hInstance: HINST;
    systemAPI: ARSystemAPI;
  public
    procedure GetName(var ppText : RString); virtual; stdcall;
    procedure GetAuthor(var ppText : RString); virtual; stdcall;
    procedure GetID(var ppID : PGUID); virtual; stdcall; abstract; 
    function GetVersion: Integer; virtual; stdcall;
    function Initialize(hInstance: HINST; hostID: Integer; hostParam: Pointer): Integer; virtual; stdcall;
    procedure LoadState(data: Pointer; size: Integer); virtual; stdcall;
    procedure Enable; virtual; stdcall;
    procedure Disable; virtual; stdcall;
    function SaveState(var data: Pointer): Integer; virtual; stdcall;
    procedure Stop; virtual; stdcall;
    procedure Free(initOK : Integer); virtual; stdcall;
  end;
  
implementation

  procedure ARGeneralPlugin.GetName(var ppText: RString); stdcall;
  begin
    ppText := MakeRString('Unknown Plug-In');
  end;

  procedure ARGeneralPlugin.GetAuthor(var ppText: RString); stdcall;
  begin
    ppText := MakeRString('Unknown');
  end;

  function ARGeneralPlugin.GetVersion: Integer; stdcall;
  begin
      Result := 1;
  end;

  function ARGeneralPlugin.Initialize(hInstance: HINST; hostID: Integer; hostParam: Pointer): Integer; stdcall;
  begin
     if hostID = AUDIO_REPEATER_PRO_HOST_ID then
      begin
        Self.hInstance := hInstance;

        if ARSystemAPIFactory(hostParam).GetSystemAPI(AUDIO_REPEATER_PRO_SYSTEM_API_V1, Pointer(systemAPI)) = R_OK then
          Result := 1
        else
          Result := 0;
      end
    else Result := 0;
  end;

  procedure ARGeneralPlugin.LoadState(data: Pointer; size: Integer); stdcall;
  begin
  end;

  procedure ARGeneralPlugin.Enable; stdcall;
  begin
  end;

  procedure ARGeneralPlugin.Disable; stdcall;
  begin
  end;

  function ARGeneralPlugin.SaveState(var data: Pointer): Integer; stdcall;
  begin
    Result := 0;
  end;

  procedure ARGeneralPlugin.Stop; stdcall;
  begin
  end;

  procedure ARGeneralPlugin.Free(initOK : Integer); stdcall;
  begin
  end;  

end.
