library ExamplePlugin3;

uses
  SysUtils,
  Classes,
  Windows,
  RObjBaseUnit in '..\Common\RObjBaseUnit.pas',
  RPluginUnit in '..\Common\RPluginUnit.pas',
  ARGeneralPluginUnit in '..\Common\ARGeneralPluginUnit.pas',
  ARGenInterfacesUnit in '..\Common\ARGenInterfacesUnit.pas',
  ARStdServicesUnit in '..\Common\ARStdServicesUnit.pas',
  PluginWindowUnit in 'PluginWindowUnit.pas' {Form1};

{$R *.res}

const
   pluginID : TGUID = '{44DBCC66-72AA-4806-AE28-B55FC5B83FC8}';

type
  TExamplePlugin3 = class(ARGeneralPlugin, ARMenuItemListener)
  protected
    pluginWindow: TForm1;
  public
    constructor Create;
    destructor Destroy; override;

    procedure GetID(var ppID : PGUID); override; stdcall;
    procedure GetName(var ppText : RString); override; stdcall;
    procedure GetAuthor(var ppText : RString); override; stdcall;

    procedure Enable; override; stdcall;
    procedure Disable; override; stdcall;

    procedure OnMenuPress(itemID : Integer); stdcall;
  end;

  constructor TExamplePlugin3.Create;
  begin
    inherited Create;
    // put your code here...
  end;

  destructor TExamplePlugin3.Destroy;
  begin
    // put your code here...
    inherited;
  end;

  procedure TExamplePlugin3.Enable; stdcall;
  var
  mainWindow: HWND;
  begin
    systemAPI.AddToPluginMenu(RSTR('Example Plug-In 3'), Self);
    systemAPI.GetApplicationWindow(mainWindow);
    
    pluginWindow := TForm1.Create(nil);
    pluginWindow.ParentWindow := mainWindow;
    pluginWindow.systemAPI := systemAPI;
    pluginWindow.Visible := True;
  end;

  procedure TExamplePlugin3.Disable; stdcall;
  begin
    systemAPI.RemoveFromPluginMenu(Self);
    pluginWindow.Destroy();
  end;

  procedure TExamplePlugin3.OnMenuPress(itemID : Integer); stdcall;
  begin
    pluginWindow.Visible := True;
  end;

  procedure TExamplePlugin3.GetName(var ppText : RString); stdcall;
  begin
     ppText := RSTR('Example Plug-In 3');
  end;

  procedure TExamplePlugin3.GetAuthor(var ppText : RString); stdcall;
  begin
     ppText := RSTR('CrownSoft');
  end;

  procedure TExamplePlugin3.GetID(var ppID : PGUID); stdcall;
  begin
    ppID := @pluginID;
  end;

procedure GetPlugin(var plugin: RPlugin); stdcall;
  begin
    plugin := TExamplePlugin3.Create;
  end;

exports
  GetPlugin;

begin
end.
 